﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadLabelCalculateSize
{
    public partial class Form1 : Form
    {
        FlowLayoutPanel flowLayoutPanel1;
        Button button1;
        List<RadLabel> labelsList = new List<RadLabel>();
        int fixedColumnSize = 100;
        
        public Form1()
        {
            InitializeComponent();

            this.flowLayoutPanel1 = new FlowLayoutPanel();
            this.flowLayoutPanel1.Dock = DockStyle.Fill;
            this.Controls.Add(flowLayoutPanel1);

            this.button1 = new Button();
            this.button1.Text = "Add Element";
            this.button1.Location = new System.Drawing.Point(13, 381);
            this.Controls.Add(this.button1);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.button1.BringToFront();
            this.button1.Click += button1_Click;
            this.Resize += Form1_Resize;
        }

        void button1_Click(object sender, EventArgs e)
        {
            TableLayoutPanel tableLayoutPanel1 = new TableLayoutPanel();
            tableLayoutPanel1.ColumnCount = 2;
            tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.AutoSize));
            tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, fixedColumnSize));
            tableLayoutPanel1.CellBorderStyle = TableLayoutPanelCellBorderStyle.Single;
            tableLayoutPanel1.AutoSize = true;
            
            RadLabel radLabel1 = new RadLabel();
            radLabel1.Text = "New Text New Text New Text New Text New Text New Text New Text New Text New Text New Text";
            radLabel1.LabelElement.MaxSize = new System.Drawing.Size(this.flowLayoutPanel1.Width - fixedColumnSize, 0);

            labelsList.Add(radLabel1);
            tableLayoutPanel1.Controls.Add(radLabel1);

            this.flowLayoutPanel1.Controls.Add(tableLayoutPanel1);
        }

        void Form1_Resize(object sender, EventArgs e)
        {
            this.SuspendLayout();
            foreach (RadLabel label in labelsList)
            {
                label.LabelElement.MaxSize = new System.Drawing.Size(this.flowLayoutPanel1.Width - fixedColumnSize, 0);
            }
            this.ResumeLayout();
        }
    }
}
